/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeTemporalEntity A temporal interval or instant.
type TimeTemporalEntity interface {
	owl.Thing
	timeAfterSingleTimeTemporalEntity
	timeHasBeginningSingleTimeInstant
	timeBeforeSingleTimeTemporalEntity
	timeHasTemporalDurationSingleTimeTemporalDuration
	timeHasXSDDurationSingleDuration
	timeHasEndSingleTimeInstant
	IsTimeTemporalEntity() bool // indicates base class
}

// sTimeTemporalEntity A temporal interval or instant.
type sTimeTemporalEntity struct {
	propCommon
	propTimeAfterBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity
	propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant
	propTimeBeforeBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity
	propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration
	propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration
	propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant
}

// NewTimeTemporalEntity creates a new TimeTemporalEntity
func (mod *Model) NewTimeTemporalEntity(iri string) (ret TimeTemporalEntity, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeTemporalEntity{}
	pc := propCommon{iri: iri, typ: "TimeTemporalEntity", model: mod}
	res.propCommon = pc
	mod.addTimeTemporalEntity(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeTemporalEntity) makeMaps() {
	return
}

// addTimeTemporalEntity adds TimeTemporalEntity to model
func (mod *Model) addTimeTemporalEntity(res TimeTemporalEntity) {
	mod.mTimeTemporalEntity[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// TimeTemporalEntity returns all resources with given prefix
func (mod *Model) TimeTemporalEntity(prefix string) (res []TimeTemporalEntity) {
	for i := range mod.mTimeTemporalEntity {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeTemporalEntity[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeTemporalEntity) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#after":
		if v, ok := obj.(TimeTemporalEntity); ok {
			if res.timeAfter.IRI() == v.IRI() {
				res.SetTimeAfter(nil)
			}
		}
	case "http://www.w3.org/2006/time#hasBeginning":
		res.propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant.removeObject(obj)
	case "http://www.w3.org/2006/time#before":
		if v, ok := obj.(TimeTemporalEntity); ok {
			if res.timeBefore.IRI() == v.IRI() {
				res.SetTimeBefore(nil)
			}
		}
	case "http://www.w3.org/2006/time#hasTemporalDuration":
		res.propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration.removeObject(obj)
	case "http://www.w3.org/2006/time#hasEnd":
		res.propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant.removeObject(obj)
	default:
	}
	return
}

// isTimeTemporalEntity indicates base class
func (res *sTimeTemporalEntity) IsTimeTemporalEntity() bool {
	return true
}

// SetTimeAfter is setter of Gives directionality to time. If a temporal entity T1 is after another temporal entity T2, then the beginning of T1 is after the end of T2.
func (res *sTimeTemporalEntity) SetTimeAfter(in TimeTemporalEntity) (err error) {
	if in != nil {
		if res.timeAfter != nil {
			if res.timeAfter.IRI() != in.IRI() {
				temp := res.timeAfter
				res.timeAfter = in
				temp.SetTimeBefore(nil)
				in.SetTimeBefore(res)
			}
		} else {
			res.timeAfter = in
			in.SetTimeBefore(res)
		}
	} else {
		if res.timeAfter != nil {
			temp := res.timeAfter
			res.timeAfter = in
			temp.SetTimeBefore(nil)
		}
	}
	return
}

// SetTimeBefore is setter of Gives directionality to time. If a temporal entity T1 is before another temporal entity T2, then the end of T1 is before the beginning of T2. Thus, \"before\" can be considered to be basic to instants and derived for intervals.
func (res *sTimeTemporalEntity) SetTimeBefore(in TimeTemporalEntity) (err error) {
	if in != nil {
		if res.timeBefore != nil {
			if res.timeBefore.IRI() != in.IRI() {
				temp := res.timeBefore
				res.timeBefore = in
				temp.SetTimeAfter(nil)
				in.SetTimeAfter(res)
			}
		} else {
			res.timeBefore = in
			in.SetTimeAfter(res)
		}
	} else {
		if res.timeBefore != nil {
			temp := res.timeBefore
			res.timeBefore = in
			temp.SetTimeAfter(nil)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeTemporalEntity) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeTemporalEntity) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#after":
		if obj, ok := res.model.mTimeTemporalEntity[pred.Object.Term.String()]; ok {
			res.SetTimeAfter(obj)
		}
	case "http://www.w3.org/2006/time#hasBeginning":
		res.propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#before":
		if obj, ok := res.model.mTimeTemporalEntity[pred.Object.Term.String()]; ok {
			res.SetTimeBefore(obj)
		}
	case "http://www.w3.org/2006/time#hasTemporalDuration":
		res.propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#hasXSDDuration":
		res.propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#hasEnd":
		res.propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeTemporalEntity) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#TemporalEntity", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeTemporalEntity) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propTimeAfterBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity.toGraph(node, g)
	res.propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant.toGraph(node, g)
	res.propTimeBeforeBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity.toGraph(node, g)
	res.propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration.toGraph(node, g)
	res.propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration.toGraph(node, g)
	res.propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeTemporalEntity) String() (ret string) {
	ret = res.iri + " " + "TimeTemporalEntity\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeTemporalEntity) propsString() (ret string) {
	ret = ""
	ret += res.propTimeAfterBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity.String()
	ret += res.propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant.String()
	ret += res.propTimeBeforeBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity.String()
	ret += res.propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration.String()
	ret += res.propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration.String()
	ret += res.propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant.String()
	return
}


